﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows;
using System.Windows.Media.Imaging;
using Microsoft.Win32;
using System.Collections.ObjectModel;
using System.Windows.Media;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Windows.Input;
using System.Collections.Generic;
using System.Windows.Data;
using System.Data;
using Telerik.Windows.Data;
using Telerik.Windows.Controls.ChartView;
using Telerik.Charting;

namespace WpfApp
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ((BarSeries)this.chart.Series[0]).ValueBinding = new GenericDataPointBinding<PlotInfo, long>()
            {
                ValueSelector = (pi) => pi.TimeSpan.Ticks
            };
        }
    }

    public class TicksStringToTimeSpan : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            long ticks = System.Convert.ToInt64(value);
            
            return TimeSpan.FromTicks(ticks).ToString("g");
        }
 
        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class MainViewModel
    {
        public ObservableCollection<PlotInfo> Data { get; private set; }

        private static readonly Random rnd = new Random(123);

        public MainViewModel()
        {
            this.Data = GetTestData(10);
        }

        private static ObservableCollection<PlotInfo> GetTestData(int dataSize)
        {
            var result = new ObservableCollection<PlotInfo>();

            result.Add(new PlotInfo { Name = "A", TimeSpan = new TimeSpan(8, 3, 8) });
            result.Add(new PlotInfo { Name = "B", TimeSpan = new TimeSpan(0, 3, 3, 33, 333) });
            result.Add(new PlotInfo { Name = "C", TimeSpan = new TimeSpan(6, 0, 0) });
            result.Add(new PlotInfo { Name = "D", TimeSpan = new TimeSpan(9, 30, 8) });
            result.Add(new PlotInfo { Name = "E", TimeSpan = new TimeSpan(0, 17, 0, 06, 213) });
            result.Add(new PlotInfo { Name = "F", TimeSpan = new TimeSpan(1, 1, 1) });

            return result;
        }
    }

    public class PlotInfo
    {
        public string Name { get; set; }
        public TimeSpan TimeSpan { get; set; }
    }
}